local function print(msg)
	DEFAULT_CHAT_FRAME:AddMessage("KSpeedO: " .. msg)
end

function KSpeedO_OnMouseDown()
	local buttonName = GetMouseButtonClicked()
	if IsShiftKeyDown() and buttonName == "LeftButton" then
		local UIParentWidth = UIParent:GetWidth()
		local UIParentHeight = UIParent:GetHeight()
		KSpeedOFrame:ClearAllPoints()
		KSpeedOFrame:SetPoint("TOPLEFT", "UIParent", "TOPLEFT", 0, 4)
	else
		KSpeedOFrame:StartMoving()
	end
	GameTooltip:Hide()
end

function KSpeedO_OnMouseUp()
	KSpeedOFrame:StopMovingOrSizing()
end

function KSpeedO_OnLoad()
    KSpeedOFrame:RegisterEvent("ADDON_LOADED")
	KSpeedOFrame:RegisterEvent("PLAYER_ENTERING_WORLD")
	KSpeedOFrame:RegisterEvent("ZONE_CHANGED")
	KSpeedOFrame:RegisterEvent("ZONE_CHANGED_NEW_AREA")
	KSpeedOFrame:RegisterEvent("ZONE_CHANGED_INDOORS")
	print("loaded.")
end

function KSpeedO_OnEvent(event)
	-- print(event)
end

function KSpeedO_OnUpdate()
	local PositionX, PositionY = GetPlayerMapPosition("player")
	local TrueSpeed = floor(((GetUnitSpeed("Player") / 7) * 100) + .5)
	local GroundSpeed = floor((((GetUnitSpeed("Player") / 7) * 100) * math.cos(GetUnitPitch("Player"))) + .5)
	if not (IsFlying() or IsSwimming()) then 
		GroundSpeed = TrueSpeed
	end
	KSpeedOText:SetText(format("X: %.2f Y: %.2f - GS: %d%%, TS: %d%%", PositionX * 100, PositionY * 100, GroundSpeed, TrueSpeed))
end